/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, String_$type, markType } from "./type";
import { Dictionary$2 } from "./Dictionary$2";
import { AnnotationLayerDescriptionMetadata } from "./AnnotationLayerDescriptionMetadata";
import { TrendLineLayerDescription } from "./TrendLineLayerDescription";
/**
 * @hidden
 */
var TrendLineLayerDescriptionMetadata = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TrendLineLayerDescriptionMetadata, _super);
    function TrendLineLayerDescriptionMetadata() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TrendLineLayerDescriptionMetadata.b = function (a) {
        if (TrendLineLayerDescriptionMetadata.a == null) {
            TrendLineLayerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
            TrendLineLayerDescriptionMetadata.c(TrendLineLayerDescriptionMetadata.a);
        }
        if (a.k(TrendLineLayerDescriptionMetadata.a)) {
            return;
        }
        a.ac(TrendLineLayerDescriptionMetadata.a);
    };
    TrendLineLayerDescriptionMetadata.c = function (a) {
        AnnotationLayerDescriptionMetadata.c(a);
        a.item("TargetSeriesName", "String");
        a.item("TargetSeriesRef", "(w:TargetSeries,wf:TargetSeries)DataRef::object");
        a.item("TrendLineType", "ExportedType:string:TrendLineType");
        a.item("TrendLineType@names", "None;LinearFit;QuadraticFit;CubicFit;QuarticFit;QuinticFit;LogarithmicFit;ExponentialFit;PowerLawFit;SimpleAverage;ExponentialAverage;ModifiedAverage;CumulativeAverage;WeightedAverage");
        a.item("TrendLinePeriod", "Number:int");
    };
    TrendLineLayerDescriptionMetadata.d = function (a) {
        TrendLineLayerDescriptionMetadata.b(a);
        a.ae("TrendLineLayer", function () { return new TrendLineLayerDescription(); });
        a.ad("TrendLineLayer", TrendLineLayerDescriptionMetadata.a);
    };
    TrendLineLayerDescriptionMetadata.$t = markType(TrendLineLayerDescriptionMetadata, 'TrendLineLayerDescriptionMetadata');
    TrendLineLayerDescriptionMetadata.a = null;
    return TrendLineLayerDescriptionMetadata;
}(Base));
export { TrendLineLayerDescriptionMetadata };
